require "coveralls"
require "knuckles"

require_relative "./support/models"
require_relative "./support/views"

Coveralls.wear!

module PrepHelper
  def prepare(objects)
    Knuckles::Pipeline.new.prepare(objects)
  end
end

RSpec.configure do |config|
  config.expect_with :rspec do |expectations|
    expectations.include_chain_clauses_in_custom_matcher_descriptions = true
  end

  config.mock_with :rspec do |mocks|
    mocks.verify_partial_doubles = true
  end

  config.disable_monkey_patching!
  config.warnings = true

  config.default_formatter = "doc" if config.files_to_run.one?

  config.order = :random
  Kernel.srand config.seed

  config.include PrepHelper
end
